package sudoku_human;
import sudoku_human.Griglia;
import sudoku_lsd.SudokuGames;


//import sudoku.*;


/*
 Created on 4-set-2005
  */

/**
 * classe contenente il main per usare l'algoritmo umano.
 * @author Marco Cornolti
 * 
 */

public class PrintSolutions {

	/**
	 * Metodo main per risolvere tutte le istanze presenti in SudokuGames con l'algoritmo
	 * umano e stamparne la soluzione.
	 */
	public static void main(String[] args) {
		int idGame=0;
	    
	    while (true) {
            int[][] grigliaIniziale;
            try {
                grigliaIniziale = SudokuGames.get(idGame);
                
            } catch (IllegalArgumentException e) {
               break;
            }
            Griglia griglia = new Griglia(grigliaIniziale);
            
            System.out.println("Sto risolvendo il sudoku di ID=" + idGame+"\n"+griglia.toStringUndefined());
            Griglia soluzione = griglia.risolvi();
            
            
            if (soluzione==null) System.out.println("Impossibile definire la soluzione!");
            
                
                    
            if (soluzione ==null||!soluzione.verifica()){
                System.out.print("Soluzione errata!");
                
            }
            
            System.out.println("Soluzione:\n" + soluzione);
            idGame++;
        }
	}
}
