package sudoku_human;
import sudoku_human.Griglia;
import sudoku_lsd.SudokuGames;

import java.util.Date;

import elab_stats.Statistiche;


/*
 Created on 4-set-2005
  */

/**
 * classe contenente il main per usare l'algoritmo umano.
 * @author Marco Cornolti
 * 
 */

public class PrintStats {

	/**
	 * Metodo main per risolvere tutte le istanze presenti in SudokuGames con l'algoritmo
	 * umano e stampare le statistiche relative all'elaborazione.
	 */
	public static void main(String[] args) {
		int idGame=0;
	    
	    while (true) {
            int[][] grigliaIniziale;
            try {
                grigliaIniziale = SudokuGames.get(idGame);
                
            } catch (IllegalArgumentException e) {
               break;
            }
            Griglia griglia = new Griglia(grigliaIniziale);
            
            Date tempoinizio = new Date();
            Griglia soluzione = griglia.risolvi();
            
            long tempoImpiegato = (((new Date()).getTime() - tempoinizio.getTime()));
            Statistiche.setTempo((int)tempoImpiegato);
            Statistiche.nextEl();
            
            if (soluzione==null) System.out.println("Impossibile definire la soluzione!");
            else Statistiche.aumentaRisolti();
            
                
                    
            if (soluzione ==null||!soluzione.verifica()){
                System.out.print("Soluzione errata!");
                
            }
            
            idGame++;
        }
	    
	    Statistiche.printSummary();
    }

}
