/*
 * Created on 5-ago-06
 */
package sudoku_human;

import java.security.InvalidParameterException;

/**
 * Classe di utilita' varie
 * @author Marco Cornolti
 *
 */
public class Utils {

    /**
     * Ordina un array di interi prendendo come base un altro array di interi col peso degli elementi nel primo array.
     * L'ordinamento avviene in modo decrescente. (l'ultimo elemento sara' il piu' leggero)
     * Il secondo verra' ordinato per la grandezza del numero, il primo subira' lo stesso ordinamento indipendentemente
     * dai suoi valori.
     * Esempio: prima weightArray=[12,56,-45], arrayToSort=[111,222,333]
     * -> dopo wieightArray==[-45,12,56], arrayToSort=[333, 111, 222]
     * algoritmo usato: selection sort
     * @param weightArray l'array di appoggio
     * @param arrayToSort l'array da ordinare
     */
    public static void sortByWeightDecrease(int[] weightArray, int[] arrayToSort){
        if (arrayToSort.length<weightArray.length) throw new InvalidParameterException();
        for (int i=0;i<arrayToSort.length;i++){
            int max=i;
            for (int k=i+1;k<arrayToSort.length;k++)
                if (weightArray[max]<weightArray[k])
                max=k; 
            if (max!=i){
            int temp=weightArray[i];
            weightArray[i]=weightArray[max];
            weightArray[max]=temp;
            temp = arrayToSort[i];
            arrayToSort[i]=arrayToSort[max];
            arrayToSort[max]=temp;
            }
        }
    }
}
