package sudoku_lsd;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class SudokuDisplay extends Frame {
    int DIM_HOR = 657, DIM_VER=730;

    Color colorB = new Color(255,255,205);
    Color colorL = new Color(255,210,230);
	
	Dimension bigB = new Dimension(66, 66);
	Dimension smallB = new Dimension(20, 20);
	Dimension backD = new Dimension(70, 30), histD = new Dimension(55, 40);
	int s0 = 10, d0 = 70, d1 = 5, b1 = 21, histx = 50, backx=294, backy=690;

	Label[][] big = new Label[9][9];
	Button[][][] small = new Button[9][9][9];
	
	Button back, auto, reset;
	Label hist;
	Sudoku S,S0;

    int history=0;
    
    Hashtable H=new Hashtable(200);
    
    Font bigFont = new Font("SansSerif", 0, 36);
    
	public SudokuDisplay(int[][] tab, int level) { 
	    Sudoku.LEVEL = level;
		this.S0 = new Sudoku(tab);
		this.S = S0;
		this.setLayout(null);
		this.setSize(new Dimension(DIM_HOR, DIM_VER));                        
		this.setFont(new Font("SansSerif", 0, 10));                      
		this.setBackground(colorB);

  		for (int i = 0; i < 9; i++) 
  			for (int j = 0; j < 9; j++) {
  			    Label newL  = new Label();
  			    int lx = s0 + j * d0 + j/3 * d1, ly = s0 + i * d0 +i/3 * d1;
  			    newL.setLocation(new Point(lx,ly+20));
  			    newL.setSize(bigB);
  			    newL.setFont(bigFont);  
   			    newL.setBackground(colorL);   
 				newL.setVisible(false);
   			    add(newL);
				big[i][j] = newL;			
		    
  				for (int k = 0; k < 9; k++) {
  					Button newB  = new Button();
  					newB.setLocation(new Point(lx + 2 + b1 * (k%3) , ly + 22 +  b1 * (k/3)));
					newB.setLabel((k+1)+"");
					newB.setVisible(false);
					newB.setSize(smallB);
					add(newB);
					newB.addActionListener(new ActionListener() {public void actionPerformed(ActionEvent e) {button(e);}});
					small[i][j][k]=newB;
					H.put(newB,new Integer(100*i+10*j+k+1));
  				}
 
 				auto = new Button();
  				auto.setLocation(new Point(backx+250, backy));
				auto.setLabel(" AUTO ");
				auto.setVisible(false);
				auto.setSize(backD);
				auto.addActionListener(new ActionListener() {public void actionPerformed(ActionEvent e) {autoHit();}});
				auto.setVisible(true);
				add(auto);

 				back = new Button();
  				back.setLocation(new Point(backx, backy));
				back.setLabel(" BACK ");
				back.setVisible(false);
				back.setSize(backD);
				back.addActionListener(new ActionListener() {public void actionPerformed(ActionEvent e) {backHit();}});
				add(back);

				reset = new Button();
  				reset.setLocation(new Point(backx-150, backy));
				reset.setLabel(" RESET ");
				reset.setVisible(false);
				reset.setSize(backD);
				reset.addActionListener(new ActionListener() {public void actionPerformed(ActionEvent e) {resetHit();}});
				add(reset);

   			    hist = new Label();
  			    hist.setLocation(new Point(histx,backy-5));
  			    hist.setSize(histD);
  			    hist.setFont(bigFont);  
   			    hist.setBackground(colorL);
   			    hist.setFont(bigFont);   
   			    hist.setVisible(false);	
   			    hist.setText("99");
   			    add(hist);
		}

		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		
	}

	public void display(){
		this.setVisible(false);
		
		history=S.movesDone();
		if(history>9)hist.setText(""+history);
		else hist.setText(" "+history);
		hist.setVisible(true);	
		
  		if(S.isDead()){this.setBackground(Color.red);}		 
  		else          {this.setBackground(colorB);} 
        
   		for (int i = 0; i < 9; i++)
  			for (int j = 0; j < 9; j++) {
  			    int v = S.getTable(i,j);
   			    if(v>0) {
   			    	for (int k = 0; k < 9; k++) small[i][j][k].setVisible(false);
   		    		big[i][j].setText("  "+v);
   		    		if(S.isInitial(i,j))big[i][j].setForeground(Color.black);
   		    		else                big[i][j].setForeground(Color.green);
    			    big[i][j].setVisible(true);
  			    } else {
  			        big[i][j].setVisible(false);
  			        for (int k = 0; k < 9; k++) 
  			        	small[i][j][k].setVisible(S.getPossibilities(i,j).contains(k+1));
				}
  		}
  		reset.setVisible(history>0);
  		back.setVisible(history>0);
  		this.setVisible(true);
 	}

	void backHit(){
		S=S.getFather();
	    display();
	}
		
	void resetHit(){
	    S=S0;
	    display();
	}
		
	void autoHit(){
		while(S.isSimple())S=new Sudoku(S, S.getGoodMove());
		display();
	}
		
	void button(ActionEvent e){
		Object o = H.get(e.getSource());
		if(o!=null)doMove(((Integer) o).intValue());
	}
	
	void doMove(int ijk){
		S=new Sudoku(S, ijk);
		display();
	}
}       		 

