package sudoku_lsd;


public class SudokuSet {
    boolean[] V = new boolean[10];
    
    public SudokuSet(){}
    
    public void add(int i) {
		if(i<1 || i>9) throw new IllegalStateException( " element "+i+"  out of range ");
		V[i]=true;
	}

	public boolean contains (int i) {
		return V[i];
	}
	
	public int size() {
		int k=0;
		for(int i = 1; i < 10; i++)if(V[i])k++;
		return k;
	}
	
	public String toString(){
	  String s="{";
	  for(int i = 1; i < 10; i++) if(V[i]) s+=" "+i;
	  return s+" }";
	}

	public SudokuSet complement(){
		SudokuSet S = new SudokuSet();
		for(int i = 1; i < 10; i++) if(!contains(i))S.add(i);
		return S;
	}	
	
	public int first(){
		for(int i = 1; i < 10; i++) if(contains(i))return i;
		throw new IllegalArgumentException( " no elements");
	}
	
	public static SudokuSet difference(SudokuSet s1, SudokuSet s2){
		SudokuSet S = new SudokuSet();
		for(int i = 1; i < 10; i++) if(s1.contains(i) && !s2.contains(i))S.add(i);
		return S;
	}	
		
	public static SudokuSet union(SudokuSet s1, SudokuSet s2){
		SudokuSet S = new SudokuSet();
		for(int i = 1; i < 10; i++) if(s1.contains(i) || s2.contains(i))S.add(i);
		return S;
	}	
}