/*
 * Created on 9-apr-2006
 */
package sudoku_state_research;


import sudoku_lsd.Sudoku;
import sudoku_lsd.SudokuGames;
import engine_lsd.Engine;
import engine_lsd.State;

/**Classe contentente il main per eseguire l'algoritmo a ricerca di spazi di stati e stampare le soluzioni.
 * @author Marco Cornolti
 *
 */
public class PrintSolutions {
    /** Eseguibile dell'algoritmo di ricerca a spazi di stati. Esegue l'algoritmo su tutte
     * le istanze di SudokuGames, stampando tutte le soluzioni.
     */
    public static void main(String[] args){

        int idGame=0;
        while (true) {
	        State initial;
	        int[][] game;
            try {
            	game = SudokuGames.get(idGame);
                
            } catch (IllegalArgumentException e) {
               break;
            }
        
            initial = new SudokuState(new Sudoku(game));
            System.out.println("Risoluzione del Sudoku con ID="+idGame+"\nStato iniziale:\n"+initial);
            
            Engine e = new Engine(initial);
            initial = e.completeSearch();
             System.out.println("Soluzione:\n"+initial);
            idGame++;
        }
        
        
    }

}
