/*
 * Created on 9-apr-2006
 */
package sudoku_state_research;

import java.util.Date;

import sudoku_lsd.Sudoku;
import sudoku_lsd.SudokuGames;
import elab_stats.Statistiche;
import engine_lsd.Engine;
import engine_lsd.State;

/**Classe contentente il main per eseguire l'algoritmo a ricerca di spazi di stati e stampare le statistiche.
 * @author Marco Cornolti
 *
 */
public class PrintStats {
    /** Eseguibile dell'algoritmo di ricerca a spazi di stati. Esegue l'algoritmo su tutte
     * le istanze di SudokuGames e prima della conclusione stampa le statistiche
     * sull'esecuzione.
     */
    public static void main(String[] args){

        int idGame=0;
        while (true) {
	        State initial;
            try {
                initial = new SudokuState(new Sudoku(SudokuGames.get(idGame)));
                
            } catch (IllegalArgumentException e) {
               break;
            }
        
            Engine e = new Engine(initial);
            Date start = new Date(); 
            initial = e.completeSearch();
            long elasped = ((Date)new Date()).getTime() - start.getTime(); 
            if (initial!=null) Statistiche.aumentaRisolti();
            Statistiche.setTempo((int)elasped);
            Statistiche.aumentaEspansioni(Engine.expandedNodes);
            Statistiche.nextEl();
             //System.out.println(""+initial+"elasped:"+elasped);
            idGame++;
        }
	    Statistiche.printSummary();
        
        
    }

}
