/*
 * Created on 9-apr-2006
 */
package sudoku_state_research;
import java.util.Iterator;
import java.util.Vector;

import engine_lsd.*;
import sudoku_lsd.*;
/** Classe che definisce lo stato di una griglia Sudoku prima, durante e dopo l'esecuzione
 * dell'algoritmo. 
 * @author Marco Cornolti
 *
 */
public class SudokuState implements State{
    
    Sudoku table;
    
    /**Costruisce uno stato da una tabella.
     * @param newtab la tabella da cui creare lo stato
     */
    public SudokuState (Sudoku newtab){
        this.table=newtab;
    }
    
    /* (non-Javadoc)
     * @see engine.State#successors()
     */
    public Iterator successors(){
        Vector moves = table.getMoves();
        Vector succ = new Vector();
        for (int i=0;i<moves.size();i++){
            Sudoku modsudoku = new Sudoku(table,((Integer)moves.get(i)).intValue());
            SudokuState modstate=new SudokuState(modsudoku);
            if (modstate.value()<1000) succ.add(modstate);
        }
        return succ.iterator();
    }
    
    /* (non-Javadoc)
     * @see engine.State#value()
     */
    public double value(){
        return table.value();
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString(){
        String tabDescr=new String();
        for (int j=0;j<9;j++){
            for (int k=0;k<9;k++){
                tabDescr += table.getTable(j,k);
                tabDescr += " ";
                
            }   
        tabDescr += "\n";
    }
        return tabDescr;
    }

}
